\section{{\em Distributed Reasoning} Modules}
\label{sec:distributedReasoning}

At the moment that this manual was wrote, there were two modules that are part of the {\em distributed reasoning} component on \emph{Somewhere2}.

\subsection{Distributed Reasoning Main Module}
This module uses the communication component and a propositional library (\emph{IASI Libs}) to handle, among other tasks, a distributed consequence finding calculus. It mainly specializes message types, message processors and some strategies specified on \emph{IASI Libs} in order to process its reasoning in a decentralized fashion. This reasoning is made by propagating query messages to concerned neighbour peers after a local consequence finding operation and incrementally combining the results obtained from theses distant peers.

There are three main special types of message on this distributed reasoning: the \emph{Query} message which triggers the local consequence finding calculus on a peer, the \emph{Answer} message which can be sent as the results of a local consequence finding operation or can be created by the combination of different answers from neighbour peers, and finally, the \emph{Finish} message which represents the end a reasoning of a propagation. For each \emph{Query} message sent from a peer, a \emph{Finish} message must be received and so then, a \emph{Finish} message can be sent from the local peer to the user or to another peer who started the propagation. If the number of finishes do not corresponds to the number of queries sent by the peer, the calculus will be ended by a \emph{timeout} routine.

Auxiliary types of messages are also used by this module.

This are the main packages of the \emph{Distributed Reasoning} main module:

\subsection{Package : {\bf fr.lri.iasi.somewhere.plogic.distributed}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[PLogicManager] The main class of the PLogic Distributed module.
	\item[PLogicQueryProcessor] Processor responsible for the "Query" message type. Launches the consequence finding strategy, return local answers (if any), propagates the queries to other peers (if needed) and wait for finish messages for each query propagated.
	\item[PLogicAnswerProcessor]	Processor responsible for the "Answer" message type. Launches the combination strategy for received messages corresponding to the query that created the related \emph{QueryProcessor}.
	\item[PLogicFinishProcessor] Processor responsible for the "Finish" message type. It waits for all concerned answers to arrive and counts down the number of \emph{Finish} messages needed to end the calculus.
	\item[PLogicAddSharedLiteralProcessor] Processor responsible for the \emph{AddSharedLiteral} message type. After this message is received by the local peer, update the shared literal index.
	\item[PLogicRemoveSharedLiteralProcessor] Processor responsible for the \emph{RemoveSharedLiteral} message type. After this message is received by the local peer, update the shared literal index.
	\item[PLogicTimeoutProcessor] Processor responsible for process the \emph{Timeout} message type.
	\item[SharedLiteralUpdater] Peer listener responsible for updating the shared literal index of a distant peer.
	\item[PLogicAnswersCollector] Message listener used to output answers and its informations to the user interface.
	\item[DistantLiteralImpl] Describes a propositional literal stored on a distant peer. Extent from the \emph{IASI Libs}.
	\item[MappingBuilder] Implementation of the Builder pattern to generate immutable clauses. The literals on the generated clause may have reference to a distant peer, classifying the generated clause as a mapping. Extent from the \emph{IASI Libs}.
	\item[PropositionalInstance] Describes a propositional instance.
	\item[PropositionalInstanceWithMapping] Describes a propositional instance with support for external mappings.
	\item[PropositionalProductionField] Represents a production set of a given instance.
\end{description}

\subsection{Package : {\bf fr.lri.iasi.somewhere.plogic.distributed.annotations}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[SubsumptionAnnotation] Describes a final answer annotation indicating subsumptions made by an answer over the answers already sent to the user.
\end{description}

\subsection{Package : {\bf fr.lri.iasi.somewhere.plogic.distributed.commands}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[AbstractBlockingUICommand] Describes a blocking UI command (blocks the UI while it does receive the necessary messages from the neighbour peers).
	\item[AddClauseCommand] A blocking ui command to add a propositional clause to the local theory.
	\item[RemoveClauseCommand] A blocking ui command to remove a propositional clause to the local theory.
	\item[CheckLoadedInstanceCommand] Command that checks if the loading instance process has finished.
	\item[QueryCommand] A command to do a propositional query on the network.
	\item[LoadPropositionalInstanceCommand] Loads a propositional instance from a file.
	\item[ShowPropositionalInstanceCommand] Shows the loaded propositional instance command.
	\item[ShowSharedLiteralsCommand] Show all shared literals of the local theory, on distant theories.
\end{description}

\subsection{Package : {\bf fr.lri.iasi.somewhere.plogic.distributed.configuration}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[PLogicConfiguration] Configuration of plogic.distributed bundle.
	\item[PLogicXMLConfiguration] Configuration, with ability to build configuration from an XML file.
\end{description}

\subsection{Package : {\bf fr.lri.iasi.somewhere.plogic.distributed.parser}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[PropositionalInstanceParsersFacade] This class is used as a facade to others parsing classes.
	\item[DIMACSInstanceParser] Parse the content of a DIMACS file into a local propositional instance.
	\item[SWRInstanceParser] Parse the content of a SWR peer profile into a propositional instance.
	\item[XMLInstanceParser] Parse the content of a XML peer profile into a propositional instance.
\end{description}

\begin{sidewaysfigure} [!hbt]
\begin{centering}
      \includegraphics[width=1.0\textwidth]{figures/parser}
\end{centering}
\caption{\label{fig:parser}  \emph{fr.lri.iasi.somewhere.plogic.distributed.parser} class diagram.}
\end{sidewaysfigure}

\subsection{Package : {\bf fr.lri.iasi.somewhere.plogic.distributed.configuration}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[PLogicConfiguration] Configuration of plogic.distributed bundle.
	\item[PLogicXMLConfiguration] Configuration, with ability to build configuration from an XML file.
\end{description}

\subsection{Package : {\bf fr.lri.iasi.somewhere.plogic.distributed.strategies}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[AnswerCombinationStrategy] Describes an answer combination strategy.
	\item[AnytimeCombinationStrategy] Describes the "any time" combination strategy.
	\item[LocallyAddClauseStrategy] Describes the add clause locally strategy.
	\item[LocallyRemoveClauseStrategy] Describes the removing clause locally strategy.
	\item[ModifyTheoryStrategy] Describes a theory modification strategy.
	\item[NaiveRemoveClauseStrategy]  Describes a naive clause removal strategy that only informs to the neighbour peers about the theory modification.
	\item[PLogicDistributedStrategiesFactory]  Singleton Strategy factory. Responsible for the instantiation of the main strategies used by the distributed processors.
\end{description}

\begin{sidewaysfigure} [!hbt]
\begin{centering}
      \includegraphics[width=1.0\textwidth]{figures/strategies}
\end{centering}
\caption{\label{fig:strategies}  \emph{fr.lri.iasi.somewhere.plogic.distributed.strategies} class diagram (main strategies).}
\end{sidewaysfigure}

\subsection{Package : {\bf fr.lri.iasi.somewhere.plogic.distributed.types}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[PLogicAddSharedLiteralType] The add shared literal message type.
	\item[PLogicAnswerMessageType] The answer message type.
	\item[PLogicFinishMessageType] The finish message type.
	\item[PLogicQueryMessageType] The query message type.
	\item[PLogicRemoveSharedLiteralType] The remove shared literal message type.
	\item[PLogicTimeoutMessageType]  The timeout message type.
\end{description}

\subsubsection{Dependencies}
Here are the dependencies of the \textbf{Distributed Reasoning} main module :
\begin{description}
	\item[BaseI module] Because it uses lots of interfaces defined there.
	\item[ui module] For sending commands
	\item[communication module] For sending messages to remote peers that contains remote propositional instances.
	\item[IASI Libs] For dealing with the propositional calculus.
\end{description}


\subsection{Inconsistency Handling Module}

This module is a extended version of the main \emph{Distributed Reasoning} module, adding some characteristics to the tasks implemented on it. An annotation representing a mapping support (mappings used for obtain a given answer) is added to every clause, and so, several operations over clauses specified on the \emph{IASI Libs} package need to be changed in order to consider this new annotation. This annotation is useful in order to reason over an inconsistent instance without consider answers that may be created using a bad mapping support (also called \emph{no-good}), in other words, answers that have a mapping support that includes a mapping support of a previously computed inconsistency, are filtered.

This module also extends the \emph{AddClause} and \emph{RemoveClause} strategies in order to collect these \emph{no-goods}.

This are the main packages of the \emph{Inconsistency Handling} module:

\subsection{{\bf fr.lri.iasi.somewhere.plogic.distributed.inconsistency}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[MappingSupport] Describes a mapping support (set of labels of mappings used to produce a clause). Extent from the \emph{IASI Libs}.
	\item[SetMappingSupport] Representation of a set of mapping support.
	\item[SetNoGood] Describes a set of supports that indicates how inconsistencies were produced.
	\item[InconsistencyAnswersCollector] Message listener used to output answers and its informations to the user interface. Responsible for combining set of mapping supports (\emph{sms}).
	\item[SNGUpdater] Updates the SNG information before sending or receiving a message.
	\item[InconsistencyManager]  The main class of the inconsistency handling module.
\end{description}

\subsection{{\bf fr.lri.iasi.somewhere.plogic.distributed.inconsistency.annotations}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[SetMappingSupportAnnotation] Clause annotation that wraps the \emph{sms} information.
\end{description}

\subsection{{\bf fr.lri.iasi.somewhere.plogic.distributed.inconsistency.commands}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[ShowNoGoodsCommand] A command to show the non goods stocked on this peer.
\end{description}

\subsection{{\bf fr.lri.iasi.somewhere.plogic.distributed.inconsistency.strategies}}
Here is a list of the classes of this package and their description :
\begin{description}
	\item[AnytimeCombinationWithSMSStrategy] Responsible for the combination of \emph{sms}s after the answer combination.
	\item[InconsistencyAddClauseStrategy] Controls the inconsistency detection by the addition of a mapping on the current theory.
	\item[ResolveClauseWithSMSStrategy] Handles the SMS information during the clause resolve process.
	\item[SubsumesClauseWithSMSStrategy] Handles the subsumption operation with the SMS annotation.
	\item[TheoryAddFormulaWithSMSStrategy] Handles the addition of a clause in a theory, considering its SMS annotation.
	\item[UnionOfClauseWithSMSStrategy] Handles the union of clauses considering the SMS information.
\end{description}

\subsection{Common related questions}

\subsubsection{How to change strategies at runtime}

The strategies factories are responsible to set the strategies used by the\emph{Distributed Reasoning} modules. They also exist at the \emph{IASI Libs} level but they are not documented on this manual.

The strategy factory that exits in this component is the \emph{PLogicDistributedStrategiesFactory} and it can used to switch:

\begin{description}
	 \item[AnswerCombinationStrategy]
	 \item[ModifyTheoryStrategy] (concerning the addition or removal of clauses).
\end{description}



